import type { Booleanish, BTableProvider, BTableSortCompare, LiteralUnion, TableField, TableFieldObject, TableItem } from '../../types';
type NoProviderTypes = 'paging' | 'sorting' | 'filtering';
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<{
    filter: {
        type: import("vue").PropType<string>;
        default: undefined;
    };
    dark: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    caption: {
        type: import("vue").PropType<string>;
        default: undefined;
    };
    small: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    align: {
        type: import("vue").PropType<import("../../types").VerticalAlign>;
        default: undefined;
    };
    variant: {
        type: import("vue").PropType<keyof import("../../types").BaseColorVariant | null>;
        default: undefined;
    };
    items: {
        type: import("vue").PropType<TableItem[]>;
        default: () => never[];
    };
    borderVariant: {
        type: import("vue").PropType<keyof import("../../types").BaseColorVariant | null>;
        default: undefined;
    };
    stacked: {
        type: import("vue").PropType<boolean | import("../../types").Breakpoint>;
        default: boolean;
    };
    busy: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    perPage: {
        type: import("vue").PropType<number>;
        default: undefined;
    };
    bordered: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    borderless: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    captionTop: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    hover: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    responsive: {
        type: import("vue").PropType<boolean | import("../../types").Breakpoint>;
        default: boolean;
    };
    striped: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    stickyHeader: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    fields: {
        type: import("vue").PropType<TableField[]>;
        default: () => never[];
    };
    footClone: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    labelStacked: {
        type: import("vue").PropType<boolean>;
        default: boolean;
    };
    showEmpty: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    emptyText: {
        type: import("vue").PropType<string>;
        default: string;
    };
    emptyFilteredText: {
        type: import("vue").PropType<string>;
        default: string;
    };
    fieldColumnClass: {
        type: import("vue").PropType<(field: TableFieldObject<Record<string, unknown>>) => Record<string, any>[]>;
        default: undefined;
    };
    tbodyTrClass: {
        type: import("vue").PropType<(item: TableItem | null, type: string) => string | any[] | null | undefined>;
        default: undefined;
    };
    provider: {
        type: import("vue").PropType<BTableProvider>;
        default: undefined;
    };
    sortCompare: {
        type: import("vue").PropType<BTableSortCompare>;
        default: undefined;
    };
    noProvider: {
        type: import("vue").PropType<NoProviderTypes[]>;
        default: undefined;
    };
    noProviderPaging: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    noProviderSorting: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    noProviderFiltering: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    sortBy: {
        type: import("vue").PropType<string>;
        default: undefined;
    };
    sortDesc: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    sortInternal: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    selectable: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    stickySelect: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    selectHead: {
        type: import("vue").PropType<string | boolean>;
        default: boolean;
    };
    selectMode: {
        type: import("vue").PropType<"range" | "single" | "multi">;
        default: string;
    };
    selectionVariant: {
        type: import("vue").PropType<keyof import("../../types").BaseColorVariant | null>;
        default: string;
    };
    busyLoadingText: {
        type: import("vue").PropType<string>;
        default: string;
    };
    currentPage: {
        type: import("vue").PropType<number>;
        default: number;
    };
    filterable: {
        type: import("vue").PropType<string[]>;
        default: undefined;
    };
}, {
    selectAllRows: () => void;
    clearSelected: () => void;
    selectRow: (index: number) => void;
    unselectRow: (index: number) => void;
    refresh: () => Promise<TableItem[] | undefined>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'head-clicked': (key: LiteralUnion<string>, field: TableField, event: MouseEvent, isFooter: boolean) => void;
    'row-clicked': (item: TableItem, index: number, event: MouseEvent) => void;
    'row-dbl-clicked': (item: TableItem, index: number, event: MouseEvent) => void;
    'row-hovered': (item: TableItem, index: number, event: MouseEvent) => void;
    'row-unhovered': (item: TableItem, index: number, event: MouseEvent) => void;
    'row-selected': (value: TableItem) => void;
    'row-unselected': (value: TableItem) => void;
    selection: (value: TableItem[]) => void;
    'update:busy': (value: boolean) => void;
    'update:sortBy': (value: string) => void;
    'update:sortDesc': (value: boolean) => void;
    sorted: (sortBy: string, isDesc: boolean) => void;
    filtered: (value: TableItem[]) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    filter: {
        type: import("vue").PropType<string>;
        default: undefined;
    };
    dark: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    caption: {
        type: import("vue").PropType<string>;
        default: undefined;
    };
    small: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    align: {
        type: import("vue").PropType<import("../../types").VerticalAlign>;
        default: undefined;
    };
    variant: {
        type: import("vue").PropType<keyof import("../../types").BaseColorVariant | null>;
        default: undefined;
    };
    items: {
        type: import("vue").PropType<TableItem[]>;
        default: () => never[];
    };
    borderVariant: {
        type: import("vue").PropType<keyof import("../../types").BaseColorVariant | null>;
        default: undefined;
    };
    stacked: {
        type: import("vue").PropType<boolean | import("../../types").Breakpoint>;
        default: boolean;
    };
    busy: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    perPage: {
        type: import("vue").PropType<number>;
        default: undefined;
    };
    bordered: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    borderless: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    captionTop: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    hover: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    responsive: {
        type: import("vue").PropType<boolean | import("../../types").Breakpoint>;
        default: boolean;
    };
    striped: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    stickyHeader: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    fields: {
        type: import("vue").PropType<TableField[]>;
        default: () => never[];
    };
    footClone: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    labelStacked: {
        type: import("vue").PropType<boolean>;
        default: boolean;
    };
    showEmpty: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    emptyText: {
        type: import("vue").PropType<string>;
        default: string;
    };
    emptyFilteredText: {
        type: import("vue").PropType<string>;
        default: string;
    };
    fieldColumnClass: {
        type: import("vue").PropType<(field: TableFieldObject<Record<string, unknown>>) => Record<string, any>[]>;
        default: undefined;
    };
    tbodyTrClass: {
        type: import("vue").PropType<(item: TableItem | null, type: string) => string | any[] | null | undefined>;
        default: undefined;
    };
    provider: {
        type: import("vue").PropType<BTableProvider>;
        default: undefined;
    };
    sortCompare: {
        type: import("vue").PropType<BTableSortCompare>;
        default: undefined;
    };
    noProvider: {
        type: import("vue").PropType<NoProviderTypes[]>;
        default: undefined;
    };
    noProviderPaging: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    noProviderSorting: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    noProviderFiltering: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    sortBy: {
        type: import("vue").PropType<string>;
        default: undefined;
    };
    sortDesc: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    sortInternal: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    selectable: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    stickySelect: {
        type: import("vue").PropType<Booleanish>;
        default: boolean;
    };
    selectHead: {
        type: import("vue").PropType<string | boolean>;
        default: boolean;
    };
    selectMode: {
        type: import("vue").PropType<"range" | "single" | "multi">;
        default: string;
    };
    selectionVariant: {
        type: import("vue").PropType<keyof import("../../types").BaseColorVariant | null>;
        default: string;
    };
    busyLoadingText: {
        type: import("vue").PropType<string>;
        default: string;
    };
    currentPage: {
        type: import("vue").PropType<number>;
        default: number;
    };
    filterable: {
        type: import("vue").PropType<string[]>;
        default: undefined;
    };
}>> & {
    "onHead-clicked"?: ((key: LiteralUnion<string>, field: TableField, event: MouseEvent, isFooter: boolean) => any) | undefined;
    "onRow-clicked"?: ((item: TableItem, index: number, event: MouseEvent) => any) | undefined;
    "onRow-dbl-clicked"?: ((item: TableItem, index: number, event: MouseEvent) => any) | undefined;
    "onRow-hovered"?: ((item: TableItem, index: number, event: MouseEvent) => any) | undefined;
    "onRow-unhovered"?: ((item: TableItem, index: number, event: MouseEvent) => any) | undefined;
    "onRow-selected"?: ((value: TableItem) => any) | undefined;
    "onRow-unselected"?: ((value: TableItem) => any) | undefined;
    onSelection?: ((value: TableItem[]) => any) | undefined;
    "onUpdate:busy"?: ((value: boolean) => any) | undefined;
    "onUpdate:sortBy"?: ((value: string) => any) | undefined;
    "onUpdate:sortDesc"?: ((value: boolean) => any) | undefined;
    onSorted?: ((sortBy: string, isDesc: boolean) => any) | undefined;
    onFiltered?: ((value: TableItem[]) => any) | undefined;
}, {
    filter: string;
    dark: Booleanish;
    caption: string;
    small: Booleanish;
    align: import("../../types").VerticalAlign;
    variant: keyof import("../../types").BaseColorVariant | null;
    items: TableItem[];
    borderVariant: keyof import("../../types").BaseColorVariant | null;
    stacked: boolean | import("../../types").Breakpoint;
    busy: Booleanish;
    perPage: number;
    bordered: Booleanish;
    borderless: Booleanish;
    captionTop: Booleanish;
    hover: Booleanish;
    responsive: boolean | import("../../types").Breakpoint;
    striped: Booleanish;
    stickyHeader: Booleanish;
    fields: TableField[];
    footClone: Booleanish;
    labelStacked: boolean;
    showEmpty: Booleanish;
    emptyText: string;
    emptyFilteredText: string;
    fieldColumnClass: (field: TableFieldObject<Record<string, unknown>>) => Record<string, any>[];
    tbodyTrClass: (item: TableItem | null, type: string) => string | any[] | null | undefined;
    provider: BTableProvider;
    sortCompare: BTableSortCompare;
    noProvider: NoProviderTypes[];
    noProviderPaging: Booleanish;
    noProviderSorting: Booleanish;
    noProviderFiltering: Booleanish;
    sortBy: string;
    sortDesc: Booleanish;
    sortInternal: Booleanish;
    selectable: Booleanish;
    stickySelect: Booleanish;
    selectHead: string | boolean;
    selectMode: "range" | "single" | "multi";
    selectionVariant: keyof import("../../types").BaseColorVariant | null;
    busyLoadingText: string;
    currentPage: number;
    filterable: string[];
}, {}>, Partial<Record<NonNullable<string | number>, (_: {
    value: unknown;
    index: number;
    item: TableItem;
    field: TableFieldObject<Record<string, unknown>>;
    items: TableItem[];
    toggleDetails: () => void;
    detailsShowing: boolean | undefined;
}) => any>> & {
    "sort-icon"?(_: {
        field: TableFieldObject<Record<string, unknown>>;
        sortBy: string | undefined;
        selected: boolean;
        isDesc: boolean;
        direction: string;
    }): any;
    "select-head"?(_: {}): any;
    "select-cell"?(_: {}): any;
    "table-busy"?(_: {}): any;
}>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
